from tkinter import *
import os
from tkinter.ttk import *
from tkinter import filedialog
from tkinter.filedialog import asksaveasfile

window = Tk()
window.title("Design into 3D")

Label(window, text='Stock Width').grid(row=0, sticky=E)
Label(window, text='Stock Thickness').grid(row=1, sticky=E)
Label(window, text='Top Bottom Thickness').grid(row=2, sticky=E)
Label(window, text='Box Width').grid(row=3, sticky=E)
Label(window, text='Box Depth').grid(row=4, sticky=E)
Label(window, text='Number of Pins').grid(row=5, sticky=E)
Label(window, text='Lid Position').grid(row=6, sticky=E)
Label(window, text='Joint Offset').grid(row=7, sticky=E)
Label(window, text='Tool Diameter').grid(row=8, sticky=E)
Label(window, text='Ball Nose Tool No').grid(row=9, sticky=E)
Label(window, text='V endmill Tool No').grid(row=10, sticky=E)
Label(window, text='Units').grid(row=11, sticky=E)
Label(window, text='Arc Detail').grid(row=12, sticky=E)

unit_systems = ("Imperial", "Metric")
selected_unit = StringVar()
unit_cb = Combobox(window, textvariable=selected_unit)
unit_cb['values'] = unit_systems
unit_cb['state'] = 'readonly'  # normal

unit_cb.current(0) #set the selected item

Stock_Width = Entry(window, justify = 'center')
Stock_Thickness = Entry(window, justify = 'center')
Top_Bottom_Thickness = Entry(window, justify = 'center')
Box_Width = Entry(window, justify = 'center')
Box_Depth = Entry(window, justify = 'center')
Number_of_Pins = Entry(window, justify = 'center')
Lid_Position = Entry(window, justify = 'center')
Joint_Offset = Entry(window, justify = 'center')
Tool_Diameter = Entry(window, justify = 'center')
Ball_Nose_Tool_No = Entry(window, justify = 'center')
V_endmill_Tool_No = Entry(window, justify = 'center')
#Units = Entry(window, justify = 'center')
Arc_Detail = Entry(window, justify = 'center')
Filename = Entry(window, justify = 'center')

Stock_Width.insert(10, "4")
Stock_Thickness.insert(10, "0.25")
Top_Bottom_Thickness.insert(10, "0.5")
Box_Width.insert(10, "8.125")
Box_Depth.insert(10, "8.125")
Number_of_Pins.insert(10, "8.125")
Lid_Position.insert(10, "0.125")
Joint_Offset.insert(10, "0.1875")
Tool_Diameter.insert(10, "0.125")
Ball_Nose_Tool_No.insert(10, "101")
V_endmill_Tool_No.insert(10, "390")
#Units = Entry(window)
Arc_Detail.insert(10, "3")
#Filename.insert(10,path)

if selected_unit == "Imperial":
    unitval = 25.4
else:
    unitval = 1

sw = float(Stock_Width.get()) * unitval
st = float(Stock_Thickness.get()) * unitval
tbt = float(Top_Bottom_Thickness.get()) * unitval
bw = float(Box_Width.get()) * unitval
bd = float(Box_Depth.get()) * unitval
jo = float(Joint_Offset.get()) * unitval
td = float(Tool_Diameter.get()) * unitval
tr = td / 2

def selectPath():
  window.path_ = filedialog.asksaveasfilename(initialdir = "/",title = "Select file",initialfile = "sample_box")
#  path.set(path_)
  Filename.insert(10, window.path_)

def previewThreeD():
  os.system('"%s"' % window.path_)

gcode = []
gcode_preamble = ['%',
#                  '(FILENAME: ' + str(window.path_) + ')',
                  '(STOCKSIZE: ' + str(bw + bd) + ', ' + str(sw) + ', ' + str(st) + ')',
                  'G21',
                  'G90']
gcode_postamble = ''

openscad = []
openscad_preamble = ['//!OpenSCAD', 'include <gcodepreview.scad>;', 'Detail = 100;', '$fn = 80;',
                     'difference() { cube([' + str(bw + bd) + ', ' + str(sw) + ', ' + str(st) + '], center=false);',
                     '{']
openscad_postamble = '}'

def addGcut(bx, by, bz, ex, ey, ez, tn):
  #'gcp_cut_radius(0, 0, 0,  4 , 0, 0, 6.35, 0.79375, 3.175);', str(gcode_line)
  global gcode
  global openscad
  openscad.append("gcut(" + str(bx) + ", " + str(by) + ", " + str(bz) + ", " + str(ex) + ", " + str(ey) + ", " + str(ez) + ", " + str(tn) + ");")
#  gcode.append("G1 X" + str(bx) + " Y" + str(by) + " Z" + str(bz))
  gcode.append("G1 X" + str(ex) + " Y" + str(ey) + " Z" + str(ez))

def addGarcCW(bx, by, bz, ex, ey, ez, xoffset, yoffset, tn):
  global gcode
  global openscad
  openscad.append("garcCW(" + str(bx) + ", " + str(by) + ", " + str(bz) + ", " + str(ex) + ", " + str(ey) + ", " + str(ez) + xoffset + ", " + yoffset + ", " + str(tn) + ");")
  gcode.append("G2 X" + str(ex) + " Y" + str(ey) + " Z" + str(ez) + " I" + xoffset + " J" + yoffset)

def addGarcCCW(bx, by, bz, ex, ey, ez, xoffset, yoffset, tn):
  global gcode
  global openscad
  openscad.append("garcCCW(" + str(bx) + ", " + str(by) + ", " + str(bz) + ", " + str(ex) + ", " + str(ey) + ", " + str(ez) + xoffset + ", " + yoffset + ", " + str(tn) + ");")
  gcode.append("G3 X" + str(ex) + " Y" + str(ey) + " Z" + str(ez) + " I" + xoffset + " J" + yoffset)

def writefiles():
  global gcode
  global openscad
  gcode_path = window.path_ + ".nc"
  openscad_path = window.path_ + ".scad"
  Filename.delete(0, END)
  Filename.insert(-1, openscad_path)
  gcode_path = window.path_ + ".nc"
  openscad = openscad_preamble
  gcode = gcode_preamble
  addGcut(1, 2, 3, 4, 5, 6, 102)
  openscad.append(openscad_postamble)
  gcode.append(gcode_postamble)

  with open(openscad_path, 'w') as f:
      for line in openscad:
          f.write(line)
          f.write('\n')

  with open(gcode_path, 'w') as f:
      for line in gcode:
          f.write(line)
          f.write('\n')

fnb = Button(text ="Set Filename", command = selectPath)
wfb = Button(text ="Write Files", command = writefiles)
previewb = Button(text ="Preview in OpenSCAD", command = previewThreeD)

Stock_Width.grid(row=0, column=1, sticky=W)
Stock_Thickness.grid(row=1, column=1, sticky=W)
Top_Bottom_Thickness.grid(row=2, column=1, sticky=W)
Box_Width.grid(row=3, column=1, sticky=W)
Box_Depth.grid(row=4, column=1, sticky=W)
Number_of_Pins.grid(row=5, column=1, sticky=W)
Lid_Position.grid(row=6, column=1, sticky=W)
Joint_Offset.grid(row=7, column=1, sticky=W)
Tool_Diameter.grid(row=8, column=1, sticky=W)
Ball_Nose_Tool_No.grid(row=9, column=1, sticky=W)
V_endmill_Tool_No.grid(row=10, column=1, sticky=W)
unit_cb.grid(row=11, column=1, sticky=W)
Arc_Detail.grid(row=12, column=1, sticky=W)
fnb.grid(row=14, column=0)
Filename.grid(row=14, column=1, sticky=W)
wfb.grid(row=15, column=0)
previewb.grid(row=15, column=1)

Stock_Width.focus()

mainloop()
